(****** Homework 5 for CS-565 Programming Languages - Purdue. ******)
(** !!!Due date: 10/14/2016 by 9:00PM **)
(* All 1, 2, and 3 stars exercises have to be completed. 4 star *)
(* exercises are optional, but completing them can compensate for failed *)
(* exercises of this and future homeworks. *)

(* Submitted by: FILL IN YOUR NAME HERE *)

Require Import Coq.Bool.Bool.
Require Import Coq.Arith.Arith.
Require Import Coq.Arith.EqNat.
Require Import Coq.omega.Omega.
Require Import Maps.
Require Import Imp.
Require Import Hoare.
Require Import Hoare2.
Require Import SfLib.
Require Import hw5.

Open Scope hoare_spec_scope.

(* ----------------------------------------------------------------- *)
(** *** Exercise: One-sided conditionals *)

(** **** Exercise: 4 stars (if1_hoare)  *)

(** In this exercise we consider extending Imp with "one-sided
    conditionals" of the form [IF1 b THEN c FI]. Here [b] is a
    boolean expression, and [c] is a command. If [b] evaluates to
    [true], then command [c] is evaluated. If [b] evaluates to
    [false], then [IF1 b THEN c FI] does nothing.

    We recommend that you do this exercise before the ones that
    follow, as it should help solidify your understanding of the
    material. *)

(** The first step is to extend the syntax of commands and introduce
    the usual notations.  (We've done this for you.  We use a separate
    module to prevent polluting the global name space.) *)

Module If2.

  Import If1.

  Lemma hoare_if1_good :
    {{ fun st => st X + st Y = st Z }}
      IF1 BNot (BEq (AId Y) (ANum 0)) THEN
      X ::= APlus (AId X) (AId Y)
      FI
      {{ fun st => st X = st Z }}.
  Proof. apply hoare_if1_good. Qed.

  Print Assumptions hoare_if1_good.

End If2.


Lemma power_series_correct
  : forall m n,
    {{ fun _ => True }}
    X ::= ANum 0;;
    Y ::= ANum 1;;
    Z ::= ANum 1;;
    WHILE BNot (BEq (AId X) (ANum m)) DO
       Z ::= AMult (ANum 2) (AId Z);;
       Y ::= APlus (AId Y) (AId Z);;
       X ::= APlus (AId X) (ANum 1)
  END
  {{ fun st => st Y = pow2 (n+1) - 1 }}.
Proof.
  apply power_series_correct.
Qed.

Print Assumptions power_series_correct.
