(****** Homework 5 for CS-565 Programming Languages - Purdue. ******)
(** !!!Due date: 10/14/2016 by 9:00PM **)
(* All 1, 2, and 3 stars exercises have to be completed. 4 star *)
(* exercises are optional, but completing them can compensate for failed *)
(* exercises of this and future homeworks. *)

(* Submitted by: FILL IN YOUR NAME HERE *)

Require Import Coq.Bool.Bool.
Require Import Coq.Arith.Arith.
Require Import Coq.Arith.EqNat.
Require Import Coq.omega.Omega.
Require Import Maps.
Require Import Imp.
Require Import Hoare.
Require Import Hoare2.
Require Import SfLib.
Require Import hw5.

Open Scope hoare_spec_scope.

Theorem hoare_asgn_fwd :
  (forall {X Y: Type} {f g : X -> Y},
     (forall (x: X), f x = g x) ->  f = g) ->
  forall m a P,
  {{fun st => P st /\ st X = m}}
    (X ::= a)
  {{fun st => P (t_update st X m)
            /\ st X = aeval (t_update st X m) a }}.
Proof.
  apply hoare_asgn_fwd.
Qed.

Lemma hoare_asgn_example4 :
  {{fun st => True}} (X ::= (ANum 1);; Y ::= (ANum 2))
  {{fun st => st X = 1 /\ st Y = 2}}.
Proof.
  apply hoare_asgn_example4.
Qed.

Theorem swap_exercise :
  {{fun st => st X <= st Y}}
  swap_program
  {{fun st => st Y <= st X}}.
Proof.
  apply swap_exercise.
Qed.

Theorem parity_correct : forall m,
    {{ fun st => st X = m }}
  WHILE BLe (ANum 2) (AId X) DO
    X ::= AMinus (AId X) (ANum 2)
  END
    {{ fun st => st X = parity m }}.
Proof.
  apply parity_correct.
Qed.

Theorem factorial_correct : forall m,
    {{ fun st => st X = m }}
  Y ::= ANum 1;;
  WHILE BNot (BEq (AId X) (ANum 0)) DO
    Y ::= AMult (AId Y) (AId X);;
    X ::= (AMinus (AId X) (ANum 1))
  END
    {{ fun st => st Y = real_fact m }}.
Proof.
  apply factorial_correct.
Qed.

Lemma two_loops_correct
  : forall (a b c : nat),
{{ fun st => True }}
  X ::= ANum 0;;
  Y ::= ANum 0;;
  Z ::= ANum c;;
  WHILE BNot (BEq (AId X) (ANum a)) DO
    X ::= APlus (AId X) (ANum 1);;
    Z ::= APlus (AId Z) (ANum 1)
  END;;
  WHILE BNot (BEq (AId Y) (ANum b)) DO
    Y ::= APlus (AId Y) (ANum 1);;
    Z ::= APlus (AId Z) (ANum 1)
  END
  {{ fun st => st Z = a + b + c }}.
Proof.
  apply two_loops_correct.
Qed.

Theorem is_wp_example :
  is_wp (fun st => st Y <= 4)
    (X ::= APlus (AId Y) (ANum 1)) (fun st => st X <= 5).
Proof.
  apply is_wp_example.
Qed.

Theorem hoare_asgn_weakest : forall Q X a,
  is_wp (Q [X |-> a]) (X ::= a) Q.
Proof.
  apply hoare_asgn_weakest.
Qed.

Print Assumptions hoare_asgn_fwd.
Print Assumptions hoare_asgn_example4.
Print Assumptions swap_exercise.
Print Assumptions parity_correct.
Print Assumptions factorial_correct.
Print Assumptions two_loops_correct.
Print Assumptions is_wp_example.
Print Assumptions hoare_asgn_weakest.
